﻿/*
 * Copyright (C) Alibaba Cloud Computing
 * All rights reserved.
 */

using Aliyun.MNS.Util;

namespace Aliyun.MNS.Model
{
    /// <summary>
    /// Container for request parameters that needed by MNS SendMessage service.
    /// </summary>
    public partial class PublishMessageRequest : SimpleMNSRequest
    {
        private string _messageBody;

        /// <summary>
        /// Empty constructor
        /// </summary>
        public PublishMessageRequest() { }

        /// <summary>
        /// Instantiates PublishMessageRequest with the parameterized properties
        /// </summary>
        /// <param name="messageBody">The message to send. </param>
        public PublishMessageRequest(string messageBody)
        {
            _messageBody = messageBody;
        }

        /// <summary>
        /// Gets and sets the property MessageBody. 
        /// </summary>
        public string MessageBody
        {
            get { return this._messageBody; }
            set { this._messageBody = value; }
        }

        // Check to see if MessageBody property is set
        internal bool IsSetMessageBody()
        {
            return this._messageBody != null;
        }

    }
}
